Description

The below calls object doesn't round trip through marshal on edge ruby:

def test_marshal_object_and_float

e = Object.new

calls = []

calls << [2.0, e]

calls << [e]

assert_equal calls, Marshal.load(Marshal.dump(calls))

end

When I run this test case, for some reason, the float takes the place of the object in the second array:

[36/82] TestMarshal#test_marshal_object_and_float = 0.00 s

1. Failure:

test_marshal_object_and_float(TestMarshal) [/Users/aaron/git/ruby/test/ruby/test_marshal.rb:40]:

<[[2.0, #Object:0x007fa5c20b08a0], [#Object:0x007fa5c20b08a0]]> expected but was

<[[2.0, #Object:0x007fa5c20b05a8], [2.0]]>.

I've attached a failing test case.

Associated revisions

Revision f45f668fa14104dab9c0e7712b6f3a3ab3d26558 - 11/16/2012 03:55 PM - nagachika (Tomoyuki Chikanaga)

marshal.c (w_object): add flonum to arg->data to keep reference index

consistency. [ruby-core:49323] [Bug #7348]

test/ruby/test_marshal.rb: add a test for above.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@37687 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision f45f668f - 11/16/2012 03:55 PM - nagachika (Tomoyuki Chikanaga)

marshal.c (w_object): add flonum to arg->data to keep reference index

consistency. [ruby-core:49323] [Bug #7348]

test/ruby/test_marshal.rb: add a test for above.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@37687 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 0f448061dec46ee8c396c772586ea560746dfe5e - 09/20/2013 03:24 PM - zzak (zzak _)

ext/openssl/lib/openssl/ssl.rb: [DOC] Document OpenSSL::SSLServer

Based on a patch by Rafal Lisowski [Bug #7348]
git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@42995 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 0f448061 - 09/20/2013 03:24 PM - zzak (zzak _)

ext/openssl/lib/openssl/ssl.rb: [DOC] Document OpenSSL::SSLServer

Based on a patch by Rafal Lisowski [Bug #7348]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@42995 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 11/14/2012 11:14 AM - mrkn (Kenta Murata)

irb(main):006:0> e = Object.new

irb(main):007:0> Marshal.load(Marshal.dump([[2.0e-100, e], [e]]))

=> [[2.0e-100, #Object:0x007fa45a10bc28], [#Object:0x007fa45a10bc28]]

Therefore it is related to flonum.

#2 - 11/14/2012 11:32 AM - shyouhei (Shyouhei Urabe)

- Status changed from Open to Assigned

- Assignee set to ko1 (Koichi Sasada)

#3 - 11/16/2012 02:38 PM - nagachika (Tomoyuki Chikanaga)

- File flonum_marshal_dump.patch added

- Category set to core

- Assignee changed from ko1 (Koichi Sasada) to nagachika (Tomoyuki Chikanaga)

- Target version set to 2.0.0

hello,

I've investigated about this issue.

When flonum is introduced at r36798, flonum is treated as immediate value in w_object(), but is should treated as reference value.

I will attach a patch. This patch introduce a trivial incompatibility. All flonum of same value are dumped as reference of same Float object. I don't think

this is not a practical problem.

(on flonum supported environment)

a = [2.0, 2.0, 2.0]

File.write("dump.txt", Marshal.dump(a))

(on flonum not supported environment)

a = Marshal.load(File.read("dump.txt"))

a.map{|f| f.object_id}  # => [70180445290980, 70180445290980, 70180445290980]

If there's no objection, I'll check-in it tonight (in JST).

#4 - 11/17/2012 12:56 AM - nagachika (Tomoyuki Chikanaga)

- Status changed from Assigned to Closed

- % Done changed from 0 to 100

This issue was solved with changeset r37687.

Aaron, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.

May Ruby be with you.

marshal.c (w_object): add flonum to arg->data to keep reference index

consistency. [ruby-core:49323] [Bug #7348]

test/ruby/test_marshal.rb: add a test for above.

#5 - 09/21/2013 12:25 AM - zzak (zzak _)

commit miss orz
Files

marshal_fail.patch 556 Bytes 11/14/2012 tenderlovemaking (Aaron Patterson)

flonum_marshal_dump.patch 954 Bytes 11/16/2012 nagachika (Tomoyuki Chikanaga)
